package com.agilecontrol.nea.core.web.shell;

import com.agilecontrol.nea.core.control.web.WebUtils;
import com.agilecontrol.nea.core.report.ReportUtils;
import com.agilecontrol.nea.core.web.shell.AbstractShellCmd;
import com.agilecontrol.nea.core.web.shell.Shell;
import com.agilecontrol.nea.util.NDSException;
import com.agilecontrol.nea.util.Validator;
import java.io.File;
import java.net.URLEncoder;
import javax.servlet.http.HttpServletRequest;
import org.json.JSONObject;

@Shell(
   alias = "get",
   help = "get file, 下载在用户文件夹目录下的文件"
)
public class Download extends AbstractShellCmd {

   private static final String CONTENT_TYPE = "text/html; charset=UTF-8";
   private static final String DOWNLOAD_TYPE = "application/octetstream; charset=GBK";


   protected JSONObject process(String args, JSONObject envObj) throws Exception {
      if(Validator.isNull(args)) {
         throw new NDSException("@cmd-argument-error@: empty file");
      } else {
         args = args.trim();
         HttpServletRequest request = (HttpServletRequest)envObj.get("request");
         ReportUtils ru = new ReportUtils(request);
         String name = String.valueOf(ru.getUser().getUserId());
         boolean isRoot = this.isAdmin(this.userWeb);
         File file = new File(args);
         if(file.isAbsolute()) {
            if(!isRoot) {
               file = null;
            }
         } else {
            file = new File(ru.getExportRootPath() + File.separator + ru.getUser().getClientDomain() + File.separator + name + File.separator + args);
         }

         this.logger.debug("Looking for " + file.getAbsolutePath());
         if(!isRoot) {
            File jo = new File(ru.getExportRootPath() + File.separator + ru.getUser().getClientDomain() + File.separator + name);
            if(!file.getParentFile().equals(jo)) {
               file = null;
            }
         }

         JSONObject jo1 = new JSONObject();
         if(file != null && file.exists() && file.isFile()) {
            jo1.put("code", 0);
            jo1.put("fileurl", WebUtils.getServletContext().getContextPath() + "/servlets/binserv/Download?filename=" + URLEncoder.encode(args, "UTF-8"));
         } else {
            jo1.put("code", -1);
            jo1.put("message", "File not found in your folder");
         }

         return jo1;
      }
   }
}
